<script setup lang="ts">
import { computed } from "vue";
import type { SizeModifierType } from "@/types/PropTypes";

const props = defineProps<{
  modalId: string;
  modalLabel: string;
  staticBackdrop?: boolean;
  sizeModifierModal?: sizeModifierModalType; // https://getbootstrap.com/docs/5.3/components/modal/#optional-sizes, e.g. sm, lg and xl
  trackModalValue?: string;
}>();

type sizeModifierModalType = SizeModifierType | "xl";

const modalSizeClass = computed<string>(() => {
  if (props.sizeModifierModal == undefined) {
    return "";
  }
  return "modal-" + props.sizeModifierModal;
});
</script>

<template>
  <div
    class="modal"
    :id="modalId"
    tabindex="-1"
    :aria-labelledby="modalLabel"
    aria-hidden="true"
    :data-bs-backdrop="staticBackdrop ? 'static' : null"
  >
    <div
      class="modal-dialog modal-dialog-centered modal-dialog-scrollable"
      :class="modalSizeClass"
    >
      <div class="modal-content">
        <div class="modal-header justify-content-between">
          <div class="modal-title fs-5" :id="modalLabel">
            <slot name="header" />
          </div>
          <div class="d-flex align-items-center">
            <slot name="extra-button" />
            <button
              type="button"
              class="btn-close"
              data-bs-dismiss="modal"
              aria-label="Close"
            ></button>
          </div>
        </div>
        <div class="modal-body">
          <slot name="body" />
        </div>
        <div class="modal-footer">
          <slot name="footer">
            <button
              type="button"
              class="btn btn-secondary"
              data-bs-dismiss="modal"
            >
              Close
            </button>
          </slot>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped></style>
